//+------------------------------------------------------------------+
//|                                                  A_Goldy_3_3.mq4 |
//|                                                              GGG |
//|                                                    Goldy_3_3.mq4 |
//| ------------------------------------------------------------------                                |
#property indicator_chart_window
#property indicator_buffers 4 
#property indicator_color1 PaleGreen // Blue 
#property indicator_color2 Red // DeepPink
#property indicator_width1 2
#property indicator_width2 2 
#property indicator_color3 PaleGreen 
#property indicator_color4 DeepPink 
#property indicator_width3 1
#property indicator_width4 1 
 
 extern int ATR_Periods = 10; 
 extern double Multiplier = 0.5; 

 double TrendUp[], TrendDown[];
 double UpBuffer[];
 double DnBuffer[];
 
 int changeOfTrend;
 // iCustom(NULL,0,"A_Goldy_3_3", ATR_Periods,Multiplier, x,i);
 //+------------------------------------------------------------------+ 
 //| Custom indicator initialization function |
 //+------------------------------------------------------------------+ 
 int init() 
   { 
  //---- indicators
   SetIndexBuffer(0, TrendUp);
   SetIndexStyle(0, DRAW_LINE, 0, 2); 
   SetIndexLabel(0, "Trend Up");
   
   SetIndexBuffer(1, TrendDown); 
   SetIndexStyle(1, DRAW_LINE, 0, 2); 
   SetIndexLabel(1, "Trend Down");
  
   SetIndexBuffer(2,UpBuffer); 
   SetIndexStyle(2,DRAW_ARROW,EMPTY); 
   SetIndexArrow(2,233);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   SetIndexLabel(2,"Up Signal");
 
   SetIndexStyle(3,DRAW_ARROW,EMPTY); 
   SetIndexBuffer(3,DnBuffer); 
   SetIndexArrow(3,234);
   SetIndexEmptyValue(3,EMPTY_VALUE);
   SetIndexLabel(3,"Down Signal"); 
   //---- 
    return(0); 
    }
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function |
 //+------------------------------------------------------------------+
  int deinit() { 
  //---- 
  //  ObjectDelete(SID); 
 //  ObjectDelete(TAG); 
  //---- 
  return(0); } 
  //+------------------------------------------------------------------+ 
  //| Custom indicator iteration function | 
//+------------------------------------------------------------------+ 
int start() 
   {
    double ClosePrice=Close[0]; 
  //  watermarkclose(TAG, tagText, tagFontSize, tagFontName, tagRGB, tagXPos, tagYPos); 
    string str=StringConcatenate("www.marketcalls.in LTP : ",ClosePrice);
     //watermarkclose(TAG,str,10, tagFontName, tagRGB, 80, 20); 
  
     int limit, i, flag, flagh, trend[5000]; 
     double up[5000], dn[5000], medianPrice, atr; 
     int counted_bars = IndicatorCounted(); 
     //---- check for possible errors 
     if(counted_bars < 0) return(-1); 
//---- last counted bar will be recounted 
  if(counted_bars > 0) counted_bars--; 
  limit=Bars-counted_bars-1; //Print(limit); 
  //---- 
  for( i = limit; i >= 0; i--) 
      {
       TrendUp[i] = EMPTY_VALUE; TrendDown[i] = EMPTY_VALUE;
     atr = iATR(NULL, 0, ATR_Periods, i); 
     //Print("atr: "+atr[i]);
     medianPrice = (High[i]+Low[i])/2; 
    //Print("medianPrice: "+medianPrice[i]);
     up[i]=medianPrice+(Multiplier*atr);
      //Print("up: "+up[i]); 
      dn[i]=medianPrice-(Multiplier*atr);
       //Print("dn: "+dn[i]); trend[i]=1; 
       if (Close[i]>up[i+1]) { trend[i]=1; 
       if (trend[i+1] == -1) changeOfTrend = 1; 
       //Print("trend: "+trend[i]); 
       } else if (Close[i]<dn[i+1]) { trend[i]=-1;
 if (trend[i+1] == 1) changeOfTrend = 1; 
 //Print("trend: "+trend[i]);
  } else if (trend[i+1]==1) { trend[i]=1; 
  changeOfTrend = 0; } 
  else if (trend[i+1]==-1)   { trend[i]=-1; changeOfTrend = 0; }
   if (trend[i]<0 && trend[i+1]>0) { flag=1; //Print("flag: "+flag);
    } else { flag=0; //Print("flagh: "+flag);
     } if (trend[i]>0 && trend[i+1]<0) { flagh=1; 
     //Print("flagh: "+flagh); 
     } else { flagh=0; 
     //Print("flagh: "+flagh);
      } if (trend[i]>0 && dn[i]<dn[i+1]) dn[i]=dn[i+1];
       if (trend[i]<0 && up[i]>up[i+1]) up[i]=up[i+1];
        if (flag==1) up[i]=medianPrice+(Multiplier*atr); 
if (flagh==1) dn[i]=medianPrice-(Multiplier*atr); 
//-- Draw the indicator 
if (trend[i]==1) { TrendUp[i]=dn[i]; 
if (changeOfTrend == 1) { TrendUp[i+1] = TrendDown[i+1]; 
changeOfTrend = 0; } } 
else if (trend[i]==-1) { TrendDown[i]=up[i];
 if (changeOfTrend == 1) { TrendDown[i+1] = TrendUp[i+1]; changeOfTrend = 0; } } 
 if (trend[i]==1 && trend[i+1]==-1) { UpBuffer[i] = iLow(Symbol(),0,i)-(3*Point); DnBuffer[i] = EMPTY_VALUE; } 
 if (trend[i]==-1 && trend[i+1]==1) { UpBuffer[i] = EMPTY_VALUE; DnBuffer[i] = iHigh(Symbol(),0,i)+(3*Point); } } 
 WindowRedraw(); 
 //---- 
 return(0); } 
//+------------------------------------------------------------------+ 
/*
void watermarkclose(string obj, string text, int fontSize, string fontName, color colour, int xPos, int yPos) 
{ ObjectCreate(obj, OBJ_LABEL, 0, 0, 0);
 ObjectSetText(obj, text, fontSize, fontName, Red); 
 ObjectSet(obj, OBJPROP_CORNER, 0); 
 ObjectSet(obj, OBJPROP_XDISTANCE, xPos);
  ObjectSet(obj, OBJPROP_YDISTANCE, yPos);
   ObjectSet(obj, OBJPROP_BACK, true);
    }  */